Page MenuHomePhabricator

Add wikitext support for citoid for automatic reference insertion
Closed, ResolvedPublic40 Story Points

Description

The Citoid extension in conjunction with the citoid service allows users of VisualEditor (a what-you-see-is-what-you-get way of editing wikis) to insert references automatically by inserting a link to a book, journal article, newspaper article, or other identifiers like DOI and PubMed IDs. However, it currently doesn't have the functionality to insert citation templates in wikitext.

There is at least one on-wiki JavaScript gadgets that already do this, i.e. https://en.wikipedia.org/wiki/User:Salix_alba/Citoid However, this relies on hard-coded wiki templates and won't work universally on other-language wikis. The reference toolbar suffers from the same problem of requiring hardcoded templates.

Event Timeline

Mvolz created this task.Mar 27 2015, 8:11 PM
Mvolz updated the task description. (Show Details)
Mvolz raised the priority of this task from to Needs Triage.
Mvolz moved this task to Backlog on the Citoid board.
Mvolz added a subscriber: Mvolz.
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptMar 27 2015, 8:11 PM
Mvolz updated the task description. (Show Details)Mar 31 2015, 9:55 PM
Mvolz set Security to None.
Mvolz updated the task description. (Show Details)
Mvolz renamed this task from Add wikitext support for citoid to Add wikitext support for citoid for automatic reference insertion.

@NiharikaKohli, Does this look acceptable as a potential project?

This one needs an additional mentor- preferably someone familiar with Extension:WikiEditor.

(@Jdforrester-WMF, your input about suitability would be great too.)

Mvolz updated the task description. (Show Details)Mar 31 2015, 10:04 PM
Jdforrester-WMF moved this task from Backlog to Extension on the Citoid board.Apr 27 2015, 8:20 PM
Jdforrester-WMF triaged this task as Normal priority.

Saving this for the next Outreachy/GSoC round. Didn't get enough time to feature this one as a potential project.

Elitre added a subscriber: Elitre.May 12 2015, 5:36 PM

Would this include creating a citation template editing interface (similar to RefToolbar)?

Ricordisamoa added a subscriber: Ricordisamoa.
Qgil added a subscriber: Qgil.Sep 23 2015, 9:09 AM

This is a message posted to all tasks under "Re-check in September 2015" at Possible-Tech-Projects. Outreachy-Round-11 is around the corner. If you want to propose this task as a featured project idea, we need a clear plan with community support, and two mentors willing to support it.

Qgil added a comment.Sep 23 2015, 9:35 AM

This is a message sent to all Possible-Tech-Projects. The new round of Wikimedia Individual Engagement Grants is open until 29 Sep. For the first time, technical projects are within scope, thanks to the feedback received at Wikimania 2015, before, and after (T105414). If someone is interested in obtaining funds to push this task, this might be a good way.

Hi. I would like to contribute to this in the upcoming round of Outreachy and hence I would like to understand more about basic background knowledge and skills required for this project. Please let me know how I can contribute. Thanks.

Mvolz added a comment.Sep 29 2015, 9:17 AM

Primarily PHP && Javascript. But a necessary precondition is also another mentor for this project since it only has one and every project needs two mentors. Someone familiar with the WikiEditor extension would be ideal. You could try send a message to wikitech-l@lists.wikimedia.org listserve looking for another mentor for this project if you're interested in taking it.

Hi. I would like to contribute to this in the upcoming round of Outreachy and hence I would like to understand more about basic background knowledge and skills required for this project. Please let me know how I can contribute. Thanks.

Mvolz added a comment.Sep 29 2015, 9:21 AM

Would this include creating a citation template editing interface (similar to RefToolbar)?

It could, but I don't view that as central component.

Qgil updated the task description. (Show Details)
Qgil added a subscriber: SalixAlba.Sep 29 2015, 9:27 AM

Maybe @SalixAlba would be interested in co-mentoring? With such team of competent mentors, the workload for each of you should be reasonable.

I have moved this project idea to the "Missing Mentors" column, and I have added the expected fields to the description. Please fill them out, especially the microtasks so @Anmolkalia and other potentially interested candidates can test their skills.

Adding this as a cross-wiki reference mechanism depends quite a lot on how references are done on other non-English wikis. I suspect other wikis use a similar system to the English one. Italian and Spanish have a {{cita web}} template which looks like a direct copy of the English {{cite web}}.

As a precursor some analysis of how references are done on a lot of wikis is needed. It would also be good to know how VE tackles the problem.

I figured we'd just use what VE uses already, which is a mediawiki
namespace message and template data. Most of the i18n issue is solved ( to
the extent that it's solved in VE anyway ). The area is fuzziest for me is
writing things for wikieditor rather than ve. The project will have to read
the template data and construct the templates, which is a solved problem in
ve. Not sure how much reinventing the wheel will be involved and how much
is built in already since I'm not familiar with the extension.

This is already something we're planning to work on in Editing. It seems a bit of a waste to duplicate efforts…

Qgil added a comment.Sep 29 2015, 5:48 PM

So... should we stop this project idea altogether? It looks like that.

Is there a task to track that Editing work? We could merge this task onto that one. If no task exists, we could repurpose this one.

So... should we stop this project idea altogether? It looks like that.

Sorry. :-(

Is there a task to track that Editing work? We could merge this task onto that one. If no task exists, we could repurpose this one.

T104479 is the super-epic; this would be a part of that (and much easier than this task, given the approach).

I think we should stick to this task. Integrating citoid with the existing editors. I would start targeting the https://en.wikipedia.org/wiki/Help:Edit_toolbar which already has quite a workable citation features. Extending that to use citoid would be a quite short manageable product which real short term benefits. I know nothing about the standard wikitext editor and the edit toolbar so I'm not sure how complex that part of the task is or even which project its part of.

If we take The Cathedral and the Bazaar analogy this would be a bazaar type project to contrast the more cathedral like VE and T104479. I think mediawiki has enough for both approaches and some non wikipedia project using MW may find utility in a small extension. Having two clients targeting Citoid would also strengthen that project and help make it more robust.

As far as producing a workable project with achievable goal. It should first target a single editor in a specific language. It should be written in an extensible way so expansion to other languages would be possible.
Writing my standalone citoid interface was a short program taking under a day to implement.

kaldari added a comment.EditedSep 29 2015, 7:02 PM

@SalixAlba: The citation features in the existing edit toolbar aren't actually part of the WikiEditor. They are from an English Wikipedia gadget called RefToolbar. RefToolbar is completely specific to English Wikipedia. In other words, it doesn't use TemplateData (https://www.mediawiki.org/wiki/Extension:TemplateData). That's why I asked if this task included creating a new template editing/inserting interface similar to RefToolbar (T94223#1280486).

FWIW, adding citoid support to RefToolbar should be trivial as it already supports doing look-ups for PMID and DOI. I would estimate a day of work. See T114156.

Mvolz added a comment.Sep 29 2015, 7:53 PM

Ah, I didn't realise a surface for wikieditor was in the works. Agreed, silly to do this then. Thanks for clearing that up James!

Mvolz updated the task description. (Show Details)Sep 29 2015, 7:56 PM

The wikitext surface may take some time, but much before then we should have mid-edit switching form wiktext to VE (currently it is only possible to go the other way) which would also make this task not really worth the effort.

Mvolz updated the task description. (Show Details)Jan 20 2016, 3:05 AM
Mvolz closed this task as Resolved.
Mvolz assigned this task to kaldari.

@kaldari added support to reftoolbar as a temporary measure until wikieditor has surface

He7d3r added a subscriber: He7d3r.Feb 10 2016, 8:53 PM

@kaldari added support to reftoolbar as a temporary measure until wikieditor has surface

I do not think it's very fair to 800 of our wikis which don't have that gadget (let alone non-WMF wikis) to claim this is "fixed" so much as "English Wikipedians aren't going to complain any more". Oh well.

No idea what to tag this with. None of the existing projects apply any more.

Jdforrester-WMF set the point value for this task to 40.May 10 2016, 1:33 AM
czar added a subscriber: czar.Jul 22 2016, 8:09 PM